//Task: schedule
//O(NlogN) solution
//Author: Rusko Shikov

#include <cstdio>
#include <iostream>
#include <string.h>
#include <vector>
#include <queue>

using namespace std;

const int maxn = 100001;

struct oper
{
  int op_no;            //   
  int succ_no;          //     (=0,     )
  int pred_count;       //    
  int fpred_count;      //    ,    
  vector<int> pred_list;//      
  int level;            //      (    1)
  bool operator<(const oper& x) const
  {
    return (level < x.level);
  }
};

oper operations[maxn+1];        //   ;  operations[i]
                                //        i
priority_queue<oper> ready_o;   //       
                                //         
                                //  - 
int ro_buff[maxn+1];  
int ro_buff_count;
                              
int n,m;

void input()
{
  int i,u,v;
  memset(operations, sizeof(operations),0);
  scanf("%d %d",&n,&m);
  for (i=1;i<=n;i++)
    operations[i].op_no=i;  
  for (i=1;i<n;i++)
  {
    scanf("%d %d",&u,&v);
    operations[u].succ_no = v;
    operations[v].pred_count++;
    operations[v].pred_list.push_back(u);
  }  
}

void BFS()          //   ,        
{
  queue<int> q;
  int i,k;
  for (i=1;i<=n;i++)            // ,           1
    if (operations[i].succ_no == 0)
    {
      operations[i].level = 1;
      q.push(i);                //     
      break;
    }
  while (!q.empty())
  {
    k = q.front();
    q.pop();
    if (operations[k].pred_count == 0)  //  ,      ,
      ready_o.push(operations[k]);      //        
                                        //   
    for (i=0;i<operations[k].pred_count;i++)
    {
      operations[operations[k].pred_list[i]].level = operations[k].level+1;
      q.push(operations[k].pred_list[i]);
    }
  }
}
       
int main()
{
  int t=0;  
  int eo,j,k,s;         //  t     (),     
  input();
  BFS();
  eo=0;                 //        0
  while (eo<n)
  {
      s=ready_o.size();
      if (s>m) s=m;
      ro_buff_count=0;
      for (j=1;j<=s;j++)
      {
          k=ready_o.top().op_no;
          ready_o.pop();
          eo++;
          operations[operations[k].succ_no].fpred_count++;
          if (operations[operations[k].succ_no].fpred_count==operations[operations[k].succ_no].pred_count)
          {
              ro_buff_count++;
              ro_buff[ro_buff_count]=operations[k].succ_no;
          }  
      }
      t++;
      for (j=1;j<=ro_buff_count;j++)
      {
         k=ro_buff[j];
         ready_o.push(operations[k]); 
      }
  }
  cout << t << endl;
  return 0;
}
