//Task: schedule
//O(N^2) solution
//Author: Rusko Shikov

#include <cstdio>
#include <iostream>
#include <string.h>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

const int maxn = 100001;

struct oper
{
  int op_no;            //   
  int succ_no;          //     (=0,     )
  vector<int> pred_list;//      
  bool d;               //     (false - ; true - )
  int level;            //      (    1)
  bool operator<(const oper& x) const
  {
    return (level > x.level);
  }
};



oper operations[maxn+1];        //   ;   operations[i]
                                //        i;    
                                //      -      
                                // pred_count  fpred_count,         
                                //   .
int pred_count[maxn+1];       //     -  pred_count[i]         i
int fpred_count[maxn+1];      //    ,     -  fpred_count[i]    
                              //     i,    
                                  
int ro_buff[maxn+1];  
int n,m;

void input()
{
  int i,u,v;
  scanf("%d %d",&n,&m);
  for (i=1;i<=n;i++)
  {
    operations[i].op_no=i;  
    operations[i].d=false;
    pred_count[i]=0;
    fpred_count[i]=0;
  }
  for (i=1;i<n;i++)
  {
    scanf("%d %d",&u,&v);
    operations[u].succ_no = v;
    pred_count[v]++;
    operations[v].pred_list.push_back(u);
  }  
}

void BFS()          //   ,        
{
  queue<int> q;
  int i,k;
  for (i=1;i<=n;i++)            // ,           1
    if (operations[i].succ_no == 0)
    {
      operations[i].level = 1;
      q.push(i);                //     
      break;
    }
  while (!q.empty())
  {
    k = q.front();
    q.pop();
    
    for (i=0;i<pred_count[k];i++)
    {
      operations[operations[k].pred_list[i]].level = operations[k].level+1;
      q.push(operations[k].pred_list[i]);
    }
  }
}

int main() 
{
  int t=0;              //  t     (),     
  int eo,j,k,s;
  input();
  BFS();
  sort(operations+1, operations+n+1);
  
  eo=0;                 //        0
  while (eo<n)
  {
      //   ,      m  - (  m)
      //    .
      //  s       
      s=0;
      for (j=1;(j<=n)&&(s<m);j++)
      {
        
        if ((!operations[j].d) && (fpred_count[operations[j].op_no] == pred_count[operations[j].op_no]))  
        {
          //      
          
          eo++; s++;
          operations[j].d=true;
          ro_buff[s]=operations[j].succ_no;  
          
        }
      }
      t++;
      
      
      for (j=1;j<=s;j++)
      {
        k=ro_buff[j];
        fpred_count[k]++;  
      }
  }
    
  cout << t << endl;  
  return 0;
}